{
| This code uses the Buffer PIC to Program
| the 16F84 and 16F877 PIC chips.
| Currently, the PIC16F877 requires the use
| of the command $18,No erase and Program.
}


unit ppdelp;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus,
{
  pic_prog_delph, CommDrv, ExtCtrls, Buttons, IniFiles,Registry, CommDrv2;
}
  pic_prog_delph, ExtCtrls, Buttons, IniFiles,Registry, CommDrv,  pic_prog_About ;


type
  TForm1 = class(TForm)
    Label1:            TLabel;
    MProg:             TMemo;
    Label2:            TLabel;
    MData:             TMemo;
    Label3:            TLabel;
    MFuses: TMemo;
    MainMenu1: TMainMenu;
    OpenDialog1: TOpenDialog;
    Memo1: TMemo;
    Label4: TLabel;
    SaveDialog1: TSaveDialog;
    File2: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    PrintSetup1: TMenuItem;
    Print1: TMenuItem;
    N2: TMenuItem;
    SaveAs2: TMenuItem;
    Save3: TMenuItem;
    Open2: TMenuItem;
    New1: TMenuItem;
    Edit2: TMenuItem;
    Object2: TMenuItem;
    Links2: TMenuItem;
    N8: TMenuItem;
    GoTo2: TMenuItem;
    Replace2: TMenuItem;
    Find2: TMenuItem;
    N9: TMenuItem;
    PasteSpecial2: TMenuItem;
    Paste2: TMenuItem;
    Copy2: TMenuItem;
    Cut2: TMenuItem;
    N10: TMenuItem;
    Repeatcommand2: TMenuItem;
    Undo2: TMenuItem;
    Button5: TButton;
    Timer1: TTimer;
    Button6: TButton;
    Button7: TButton;
    BitBtn1: TBitBtn;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    ReopenLast1: TMenuItem;
    Button2: TButton;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    About1: TMenuItem;
    CommPortDriver1: TCommPortDriver;
    Button1: TButton;
    ComboBox1: TComboBox;
    Button3: TButton;
    Button4: TButton;
    Label11: TLabel;
    Edit1: TEdit;
    Label12: TLabel;
    Label13: TLabel;
    Button8: TButton;
    Button13: TButton;
    Button14: TButton;
    Edit3: TEdit;
    Button15: TButton;
    Button16: TButton;
    CB_inc_prog: TCheckBox;
    CB_inc_data: TCheckBox;
    CB_inc_conf: TCheckBox;
    RG_device: TRadioGroup;
    Button17: TButton;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    Label15: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    procedure Open2Click(Sender: TObject);
    procedure Save3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure ReopenLast1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure file11Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure Button17Click(Sender: TObject);


  private
    { Private declarations }
    procedure processMemo;
    procedure InitButtonStates;


  public
    { Public declarations }
  end;

type
  progModeT = ( readData, readProg,readFuses,
                bulkEraseProg,bulkEraseData,bulkEraseBoth,
                progProg,progData,progFuses
              );



{
 TABLE 3-1: COMMAND MAPPING FOR PIC10F200/202/204/206
Command Mapping (MSb  LSb) Data
Load Data for Program Memory     x x 0 0 1 0    0, data (14), 0
Read Data from Program Memory    x x 0 1 0 0    0, data (14), 0
Increment Address                x x 0 1 1 0
Begin Programming                x x 1 0 0 0 Externally Timed
End Programming                  x x 1 1 1 0
Bulk Erase Program Memory        x x 1 0 0 1 Internally Timed
}

const
     LD_CONF       = $00;
     LD_PRG_MEM    = $02;
     RD_PRG_MEM    = $04;
     INC_ADDR      = $06;
     PROG          = $08;
     PROG_NO_ERASE = $08; { $18 }  { on 12F675 PRO externally timed }

     PROG_STOP   = $0E;
     LD_DATA_MEM = $03;
     RD_DATA_MEM = $05;
     ERASE_PROG  = $09;
     ERASE_DATA  = $0B;
     DIS_PROTECT1= $01;
     DIS_PROTECT2= $07;

     Voff          = $20;
     Vpp           = $21;
     V5VnVpp       = $22;
     V5VVpp        = $23;
     VInvAllOff    = $24;
     VInv5V        = $25;
     VInv5VVpp     = $26;
{
     ; The XX only apply to the 16F877
;
;	Specials for turning on the +5 volts and 5 Vpp
;
;all Off			100000
;Vpp On				100001
;+5  On,Vpp Off			100010
;+5  On,Vpp On			100011
;
;

}

var
  Form1        : TForm1;
  HexData,ChipData      : HexDataT;
  chipAddress  : integer;
  state,temp   : integer;
  cnt1,cnt2,cnt3    : integer;
  progMode     : progModeT;
  opStr        : string;
  dwEvtMask    : DWORD;
  Errors       : boolean;
  BlankChip    : boolean;
  ChipSame     : boolean;
  FileName     : string;
  FileNameA    : array[0..4] of string;
  IniFile      : TRegIniFile;
  NeedsWait    : boolean;


implementation

uses ppdelp;

{$R *.DFM}

procedure wrtCMD(cmd:integer); forward;


procedure TForm1.Open2Click(Sender: TObject);
var
   cnt, cnt2 : integer;
begin
  OpenDialog1.FileName := '*.hex';
  if OpenDialog1.Execute then
  begin
    Memo1.Lines.LoadfromFile(OpenDialog1.FileName);
    SaveDialog1.Filename := OpenDialog1.FileName;
    Caption := OpenDialog1.FileName;
    Filename := OpenDialog1.FileName;
    FilenameA[4] := FilenameA[3];
    FilenameA[3] := FilenameA[2];
    FilenameA[2] := FilenameA[1];
    FilenameA[1] := FilenameA[0];
    FilenameA[0] := Filename;

    ComboBox1.Items.Strings[0] := FilenameA[0];
    ComboBox1.Items.Strings[1] := FilenameA[1];
    ComboBox1.Items.Strings[2] := FilenameA[2];
    ComboBox1.Items.Strings[3] := FilenameA[3];
    ComboBox1.Items.Strings[4] := FilenameA[4];

    IniFile.WriteString('files','lastFile0',FileNameA[0]);
    IniFile.WriteString('files','lastFile1',FileNameA[1]);
    IniFile.WriteString('files','lastFile2',FileNameA[2]);
    IniFile.WriteString('files','lastFile3',FileNameA[3]);
    IniFile.WriteString('files','lastFile4',FileNameA[4]);

    ComboBox1.Items.Insert( 0, Filename );
    ComboBox1.text :=  Filename ;

    processMemo;
  end;
end;

procedure TForm1.Save3Click(Sender: TObject);
begin
 if OpenDialog1.Execute then
  begin
    Memo1.Lines.LoadfromFile(OpenDialog1.FileName);
    SaveDialog1.Filename := OpenDialog1.FileName;
    Caption := OpenDialog1.FileName;
  end;

end;

{
; The Crownhill is a serial port programmer.
; TXD -> VPP and +5, To apply, Set the BREAK to apply continously
; DTR -> Data to
; RTS -> Clock
; CTS <- Data from PIC
;
;
}

procedure ConnectComPort;
begin

{  Form1.CommPortDriver1.ComPort:= pnCOM1 ; }
  Form1.CommPortDriver1.ComPort:= TComPortNumber( StrToInt( Form1.Edit1.Text ) - 1 ) ;
  Form1.CommPortDriver1.Connect;
  if Form1.CommPortDriver1.Connected then
  begin
    dwEvtMask :=EV_CTS  or EV_DSR or EV_RING  or EV_RLSD;
    dwEvtMask := 0;

    SetCommMask( Form1.CommPortDriver1.FComPortHandle,dwEvtMask);
  end;
end;

procedure DisConnectComPort;
begin
  Form1.CommPortDriver1.ComPort:= pnCOM5 ;
  Form1.CommPortDriver1.Connect;
  if Form1.CommPortDriver1.Connected then
  begin

   { dwEvtMask :=EV_CTS  or EV_DSR or EV_RING  or EV_RLSD; }

    dwEvtMask := not EV_CTS  or not EV_DSR or not EV_RING  or not EV_RLSD;

    SetCommMask( Form1.CommPortDriver1.FComPortHandle,dwEvtMask);
    Form1.CommPortDriver1.Disconnect;
  end;
end;



function rdDataBit:boolean;
var
   ret : boolean;
   a : TCOMSTAT;
   dwEvtMask: DWORD;
   lpModemStat: DWORD;
begin
  if Form1.CommPortDriver1.Connected then
  begin
    dwEvtMask :=EV_CTS  or EV_DSR or EV_RING  or EV_RLSD;
    ret := GetCommMask( Form1.CommPortDriver1.FComPortHandle,dwEvtMask);
    ret := GetCommModemStatus(Form1.CommPortDriver1.FComPortHandle, lpModemStat);
    rdDataBit :=  (  $0010 = ( lpModemStat and ( $0010 ) ) ) ;
  end;
end;

function rdClkOBit:boolean;
var
   ret : boolean;
   a : TCOMSTAT;
   dwEvtMask: DWORD;
   lpModemStat: DWORD;
begin
  if Form1.CommPortDriver1.Connected then
  begin
    dwEvtMask :=EV_CTS  or EV_DSR or EV_RING  or EV_RLSD;
    ret := GetCommMask( Form1.CommPortDriver1.FComPortHandle,dwEvtMask);
    ret := GetCommModemStatus(Form1.CommPortDriver1.FComPortHandle, lpModemStat);
    rdClkOBit :=  (  $0020 = ( lpModemStat and ( $0020 ) ) ) ;
  end;
end;

function rdDataOBit:boolean;
var
   ret : boolean;
   a : TCOMSTAT;
   dwEvtMask: DWORD;
   lpModemStat: DWORD;
begin
  if Form1.CommPortDriver1.Connected then
  begin
    dwEvtMask :=EV_CTS  or EV_DSR or EV_RING  or EV_RLSD;
    ret := GetCommMask( Form1.CommPortDriver1.FComPortHandle,dwEvtMask);
    ret := GetCommModemStatus(Form1.CommPortDriver1.FComPortHandle, lpModemStat);
    rdDataOBit :=  (  $0080 = ( lpModemStat and ( $0080 ) ) ) ;
  end;
end;



procedure setClk;{(Sender: TObject);}
var
   count : integer;
begin
  count := 0;
  if Form1.CommPortDriver1.Connected then
  begin
    EscapeCommFunction( Form1.CommPortDriver1.FComPortHandle,SETRTS);
  repeat until ( rdClkOBit or NOT  NeedsWait )  ;
  end;
  Form1.Label7.caption := IntToStr( count );
end;

procedure resetClk;
var
   count : integer;
begin
  count := 0;
  if Form1.CommPortDriver1.Connected then
  begin
    EscapeCommFunction( Form1.CommPortDriver1.FComPortHandle,CLRRTS);
    repeat until ( not rdClkOBit or NOT  NeedsWait )  ;
  end;
  Form1.Label8.caption := IntToStr( count );
end;

procedure setData;
begin
  if Form1.CommPortDriver1.Connected then
  begin
    EscapeCommFunction( Form1.CommPortDriver1.FComPortHandle,SETDTR);
  end;
end;

procedure resetData;
begin
  if Form1.CommPortDriver1.Connected then
  begin
    EscapeCommFunction( Form1.CommPortDriver1.FComPortHandle,CLRDTR);
  end;
end;


procedure setVPP;
begin
  if Form1.CommPortDriver1.Connected then
  begin
    SetCommBreak( Form1.CommPortDriver1.FComPortHandle);
  end;
end;

procedure resetVPP;
begin
  if Form1.CommPortDriver1.Connected then
  begin
    ClearCommBreak( Form1.CommPortDriver1.FComPortHandle);
  end;
end;


procedure Apply5VandVPP;
begin
  setVPP;
   if NeedsWait then
      wrtCmd(  $20 );
end;

procedure Apply5V;
begin
  setVPP;
  if NeedsWait then
    wrtCmd(  $22 );
end;

procedure Remove5VandVpp;
begin
 resetVPP;
 if NeedsWait then
   wrtCmd(  $23 );
end;

{ MicroChip 24C08B/16B functions }

{
     iiC principles:
     Only change data while clk is low
     so
     Start bit is signified by taking Data low while clk is high
     Stop  bit is signified by taking Data high while clk is high

     Start:
           clk   ---\____
           data  --\____

     0:
           clk   __/--\__
           data  ________

     0:
           clk   ____/--\________
           data  _/--------\_____


     Stop:
           clk   __/--------
           data  ___/-------




  }

procedure ApplyIICpower;
begin
  setVPP;
  setData;
  setClk;
  {apply power }
  setVPP;
  if NeedsWait then
    wrtCmd(  $22 );

end;

procedure ApplyIICStart;
begin
  setData;
  setClk;
  resetData;
  resetClk;

  if NeedsWait then
    wrtCmd(  $22 );
end;

procedure ApplyIIC_zero;
begin
  resetData;
  setClk;
  setClk;
  resetClk;
  resetData;
  if NeedsWait then
    wrtCmd(  $22 );
end;


procedure ApplyIIC_one;
begin
  setData;
  setClk;
  setClk;
  resetClk;
  resetData;
  if NeedsWait then
    wrtCmd(  $22 );
end;


procedure ApplyIICStop;
begin
  resetData;
  resetClk;
  setClk;
  setClk;
  setData;
  if NeedsWait then
    wrtCmd(  $22 );
end;

function readIICbit:boolean;
begin
  setData;
  setClk;
  setClk;
  readIICbit := rdDataBit;
  resetClk;
  resetData;

end;

function readIICbyte:integer;
var
  cnt: integer;
  temp : integer;
begin
  temp := 0;
  { MSB first }
  for cnt := 0 to 7 do
  begin
    if readIICbit then
      temp := temp + temp + 1
    else
      temp := temp + temp;
  end;
  readIICbyte := temp;
end;

function writeIICbyte( value:integer ):boolean;
var
  cnt: integer;
  temp : integer;
  pwr2 : integer;
begin
  temp := value;
  pwr2 := 1;
  { MSB first }
  for cnt := 0 to 7 do
  begin
    if ( temp and $80 ) <> 0 then
      ApplyIIC_one
    else
      ApplyIIC_zero;

    temp := temp shl 1
  end;
  { read ACK }
  writeIICbyte := readIICbit;
end;


{ -----------------------------------------------------------}

procedure wrtCMD(cmd:integer);
var
  cnt : byte;
begin
  { zero bits }
  resetData;
  resetClk;
  for cnt := 0 to 5 do
  BEGIN
    if 0 = ( cmd and 1 )
    then
    begin
      resetData;
    end
    else
    begin
      setData;
    end;
    setClk;
    resetClk;
    cmd := cmd shr 1 ;
  END;
  { Turn data line into input, just incase command is read }
end;

procedure wrtData(cmd:integer);
var
  cnt : byte;
begin
  { zero bits }
  cmd := cmd shl 1;
  for cnt := 0 to 15 do
  BEGIN
    if 0 = ( cmd and 1 )
    then
    begin
      resetData;
    end
    else
    begin
      setData;
    end;
    setClk;
    resetClk;
    cmd := cmd shr 1 ;
  END;
end;

function rdData:integer;
var
  cnt : byte;
  cmd : integer;
  readBit : boolean;
begin
  cmd := 0;
  resetData;
  resetClk;
  { Clock one bit }
  setClk;
  resetClk;
  for cnt := 0 to 14 do
  BEGIN
    setData; { Bias the PIC }
    setClk;
    { data is being presented }
    { data should  not be present }
    if NeedsWait then
       readBit := rdDataOBit
       else
       readBit := rdDataBit;
    if not readBit
    then
    begin
      cmd := cmd shr 1 ;
    end
    else
    begin
      cmd := cmd shr 1 ;
      cmd := cmd or $4000 ;
    end;
    resetClk;
  END;
  rdData := cmd and $3FFF;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
  cnt1,cnt2,temp:integer;
begin
  MProg.lines.clear;
  progMode := readProg;
  state := 1;
end;



procedure TForm1.InitButtonStates;
begin
       NeedsWait       := FALSE;

       Button1.enabled  :=false;
       Button2.enabled  :=false;
       Button3.enabled  :=false;
       Button4.enabled  :=false;
       Button5.enabled  :=false;

       Button6.enabled  :=false;
       Button7.enabled  :=false;
       Button8.enabled  :=false;
       Button9.enabled  :=false;
       Button10.enabled :=false;

       Button11.enabled :=false;
       Button12.enabled :=false;
       Button13.enabled :=false;
       Button14.enabled :=false;
       Button15.enabled :=false;

       Button16.enabled :=false;
       Button17.enabled :=false;

       BitBtn1.enabled  :=true;

       Form1.Cursor :=  crHourGlass;
       Label5.caption := 'Programming...';

       BlankChip    := TRUE;
       ChipSame     := TRUE;

       Remove5VandVPP;
       resetData;
       resetClk;

end;


procedure TForm1.Timer1Timer(Sender: TObject);
var
  finished :boolean;
  skipped  :boolean;
  bit      :boolean;
  temp     :integer;
  cnt      :integer;
  cnt2     :integer;
  nackSeen :boolean;
  memSize  :integer;
  getTicks :dword;

  byteStr : string;
 begin

   if Form1.CommPortDriver1.Connected then
     label11.caption :='connected'
   else
     label11.caption :='.........';


     { Timer is used to pause delays }
     Label5.caption := 'State 0x'+intToHex( state,4 );
     case state of
     1:
     { Put the chip into programme mode }
     Begin
       InitButtonStates;

       ConnectComPort;
       { zero bits }
       resetData;
       resetClk;

       Remove5VandVPP;

       state  := 3;

     end;

     3:
     Begin
       resetData;
       resetClk;
       Apply5V;
       state  := state +1;
       Label5.caption := 'Programming...';
     end;
     10:
     {
     With 5volts on Chip, bounce MCLR/VPP pin,
     Programming mode is entered if
     data and Clk = 0 when Vpp raised to 12 volts.
     Most 16F84 seems to programme well outside
     the spec.
     }
     Begin
       resetData;
       resetClk;
       Remove5VandVPP;
       state  := 11;
     end;

     11:
     {
     With 5volts on Chip, bounce MCLR/VPP pin,
     Programming mode is entered if
     data and Clk = 0 when Vpp raised to 12 volts.
     Most 16F84 seems to programme well outside
     the spec.
     }
     Begin
       resetData;
       resetClk;

       Remove5VandVPP;
       state  := 12;
     end;


     { progress with a bit of delay }
     12..19:
     Begin
       resetData;
       resetClk;
       Apply5V;
       state  := state +1;
     end;

     20:
     Begin
       resetData;
       resetClk;
       Apply5VandVPP;
       state  := state +1;
       cnt1:=0;
       cnt2:=0;

       case progMode of
           readData:       MData.lines.add('.............');
           readProg:       MProg.lines.add('.............');
           readFuses:      MFuses.lines.add('.............');
           bulkEraseData:  MData.lines.add('..erase......');
       else
       end;
       opStr  := '';
     end;

     { branch to different sections on programming mode }
     21:
     begin
       { Putting the chip into Config area needs extra instructions }
       if progMode = readFuses then
       begin
         wrtCmd(  LD_CONF );
         wrtData( $3FFF );
       end;
       state  := $4F0;

       case progMode of
         readData:  chipAddress := $2100;
         bulkEraseData: chipAddress := $2100;
         readProg:  chipAddress := $0000;
         readFuses: chipAddress := $2000;

         progProg,progData,progFuses: chipAddress := $0000;
       else
       end;

       case progMode of
         { reading from the chip }
         readData,
         readProg,
         readFuses:
         begin
           //state := $40;
           state := $3F;
         end;

         { bulk erase }
         bulkEraseProg: state := $A00; { do a bulk erase of both }
         bulkEraseData: state := $A10;
         bulkEraseBoth: state := $A20;


         { Program the sections of the chip }
         // progProg:  state := $B00;
         progProg:  state := $AFC;
         progData:  state := $B04;
         progFuses: state := $B08;


       else
       end;
     end;


     30:
     begin
       case progMode of
         readData:  wrtCmd( RD_DATA_MEM  );
         readProg:  wrtCmd( RD_PRG_MEM  );
         readFuses: wrtCmd( RD_PRG_MEM  );
       else
       end;
       {wrtCmd( RD_PRG_MEM  );}
       temp := rdData;
       if temp <> $3FFF then BlankChip := FALSE;
       if hexData.data[ chipAddress ] <> temp then chipSame :=FALSE;

       chipData.data[ chipAddress ] := temp;
       chipAddress := chipAddress +1 ;

       wrtCmd(INC_ADDR);
       cnt1 := cnt1+1;
       opStr := opStr + ' ' + IntToHex( temp, 4 );
       if cnt1 = 8 then
       begin
         opstr := IntToHex( cnt2,4 )+' : ' + opStr;
         case progMode of
           readData:       MData.lines.add( opStr );
           readProg:       MProg.lines.add( opStr );
           readFuses:      MFuses.lines.add(opStr );
         else
         end;
         opStr := '';
         cnt2  := cnt2+8;
         cnt1  := 0;
       end;


       case progMode of
         readData:   if chipAddress = $2100 + 63 then state := $31;
         readProg:   if chipAddress = $400       then state := $31;
         readFuses:  if chipAddress = $2008      then state := $31;
       else
       end;
     end;

     $31:
     Begin
       opstr := IntToHex( cnt2,4 )+' : ' + opStr;
       case progMode of
         readData:       MData.lines.add(opStr);
         readProg:       MProg.lines.add(opStr);
         readFuses:      MFuses.lines.add(opStr);
       else
       end;
       opstr := '-----------';
       if blankChip then
       begin
         opstr := opstr +': Blank   Chip ';
       end;
       if chipSame  then
       begin
         opstr := opstr +': Chip == File ';
       end;
       opstr := opStr + ': -----------';

       case progMode of
         readData:       MData.lines.add(opStr);
         readProg:       MProg.lines.add(opStr);
         readFuses:      MFuses.lines.add(opStr);
       else
       end;

       Label5.caption := 'Finished';
       state := $1000;
     end;


     { Reading a 10F204 device
       The CONF is available between Reset and first INC_ADDR

       Reading PROG
         reset device
         INC_ADDR
         send RD_PRG_MEM

        Reading DATA
         Not available

        Reading CONF
         reset device
         send RD_PRG_MEM
         INC_ADDR
      }

     { Reading a device

       Reading PROG
         reset device
         send RD_PRG_MEM

        Reading DATA
         reset device
         send RD_DATA_MEM

        Reading CONF
         send LD_CONF
         send RD_PRG_MEM
      }

     $3F:
     begin


       case RG_device.ItemIndex of
       2: { 10F204 devices }
       begin
         { Only available between reset and first INC_ADDRESS }
         wrtCmd( RD_PRG_MEM  );
         temp  := rdData;
         opStr := ' Config fuses: ';

         wrtCmd( INC_ADDR );
         opStr := opStr + ' ' + IntToHex( temp, 4 );
         MProg.lines.add(opStr);
         state := $40;
       end
       else
       begin
         state := $40;
       end;
       end;{case}
       state := $40;
     end;



     $40:
     begin

       { each read  is requested by button }
       case progMode of
         readData:  wrtCmd( RD_DATA_MEM  );
         readProg:  wrtCmd( RD_PRG_MEM  );
         readFuses: wrtCmd( RD_PRG_MEM  );
       else
       end;


       {wrtCmd( RD_PRG_MEM  );}
       { Do a read not sure why }
       opStr :='';
       case progMode of
           readData:  wrtCmd( RD_DATA_MEM  );
           readProg:  wrtCmd( RD_PRG_MEM  );
           readFuses: wrtCmd( RD_PRG_MEM  );
       else
       end;
       temp  := rdData;
       if temp <> $3FFF then BlankChip := FALSE;
       if hexData.data[ chipAddress ] <> temp then chipSame :=FALSE;

       opStr := IntToHex( chipAddress, 4 )+' :';

       for cnt1 := 0 to 7 do
       begin
         case progMode of
           readData:  wrtCmd( RD_DATA_MEM  );
           readProg:  wrtCmd( RD_PRG_MEM  );
           readFuses: wrtCmd( RD_PRG_MEM  );
         else
         end;
         temp  := rdData;
         if temp <> $3FFF then BlankChip := FALSE;
         if hexData.data[ chipAddress ] <> temp then chipSame :=FALSE;

         chipData.data[ chipAddress ] := temp;
         chipAddress := chipAddress +1 ;
         wrtCmd(INC_ADDR);
         opStr := opStr + ' ' + IntToHex( temp, 4 );
       end;
       //opstr := IntToHex( cnt2,4 ) + ' : ' + opStr;

       case progMode of
         readData:       MData.lines.add(opStr);
         readProg:       MProg.lines.add(opStr);
         readFuses:      MFuses.lines.add(opStr);
       else
       end;
       cnt2  := cnt2  +8;
       case progMode of
         readData:   if chipAddress > $2100 + 255 then state := $41;
         readProg:   if chipAddress > $400 -1    then state := $41;
         readFuses:  if chipAddress > $2008-1    then state := $41;
       else
       end;
     end;

     $41:
     Begin
       opstr := '-----------';
       if blankChip = TRUE then opstr := opstr +': Blank   Chip ';
       if chipSame  = TRUE then opstr := opstr +': Chip == File ';
       opstr := opStr + ': -----------';

       case progMode of
         readData:       MData.lines.add(opStr);
         readProg:       MProg.lines.add(opStr);
         readFuses:      MFuses.lines.add(opStr);
       else
       end;
       Remove5VandVPP;
       state := $1000;
       Label5.caption := 'Finished';
     end;



     $50:
     Begin
       InitButtonStates;

       ConnectComPort;
       { zero bits }
       resetData;
       resetClk;

       Remove5VandVPP;
       BlankChip    := TRUE;
       ChipSame     := TRUE;

       state  := state +1;
       label5.caption := 'Erasing 10F204...';
     end;

     $52:
     Begin
       resetData;
       resetClk;
       Apply5VandVPP;
       state  := state +1;
     end;

     $54:
     Begin
       wrtCmd( ERASE_PROG );
       state  := state +1;
     end;


     $58:
     Begin
       Remove5VandVPP;
       state := $1000;
       Label5.caption := 'Finished';
     end;


     $60: { Program 10F204 fuses }
     Begin
       InitButtonStates;

       Remove5VandVPP;

       BlankChip    := TRUE;
       ChipSame     := TRUE;

       Form1.Cursor :=  crHourGlass;
       ConnectComPort;
       { zero bits }

       resetData;
       resetClk;
       Remove5VandVPP;
       state  := state +1;
       label5.caption := 'Programming fuses 10F204 ...';

     end;

     $62:
     Begin
       resetData;
       resetClk;
       Apply5VandVPP;
       state  := state +1;
     end;

     $64:
     Begin
       wrtCmd( LD_PRG_MEM );
       // pick up configuration word
       wrtData( hexData.data[ $0FFF ] );
       wrtCmd( PROG_NO_ERASE ); {  For 16F877 use NO_ERASE_PROG }
       state  := state +1;
     end;

     $65:
     Begin
       wrtCmd( PROG_STOP ); {  For 16F877 use NO_ERASE_PROG }
       state  := state +1;
     end;

     $66:
     Begin
       Remove5VandVPP;
       state := $1000;
       Label5.caption := 'Finished';
     end;

     {
     24L16 summary

         CMD.W ADDR   note: the cmd contains 3 bits of ADDR

         CMD.W ADDR DATA .. DATA    up to 8 words

         CMD.R getDATA getDATA

     24L65 summary   ( not includeing write protect features )

         CMD.W ADDR ADDR

         CMD.W ADDR ADDR DATA .. DATA    up to 64 words

         CMD.R getDATA getDATA


     }
     $100: { IIC function}
     begin
       InitButtonStates;

       ConnectComPort;
       Memo1.lines.add( ' .. IIC mode...');
       chipAddress := $0000;
       ApplyIICpower;
       cnt3 := 0;
       state := state + 1;
     end;

     $108: { IIC function}
     begin
       ApplyIICStart;
       state := state + 1;
       if ComboBox2.ItemIndex = 0 then
         state := $110;

     end;

     $109: { IIC function}
     begin
       { Reading 24LC65 device }
       Memo1.lines.add( ' Reading 24LC65 device ');

       { CMD.W ADDR ADDR }
       { send control 0xA0  write }
       if writeIICbyte( $A0 ) then
         Memo1.lines.add( ' cmd ..NACK..')
       else
         Memo1.lines.add( ' cmd ..ACK..');

       { start Address High Byte}
       if writeIICbyte( $00 ) then
         Memo1.lines.add( ' adr ..NACK..')
       else
         Memo1.lines.add( ' adr ..ACK..');

       { start Address low Byte}
       if writeIICbyte( $00 ) then
         Memo1.lines.add( ' adr ..NACK..')
       else
         Memo1.lines.add( ' adr ..ACK..');

       ApplyIICStop;
       state := state + 1;
     end;

     $10A: { IIC function}
     begin
       ApplyIICStart;
       { CMD.R getDATA getDATA }
       if writeIICbyte( $A1 ) then
         Memo1.lines.add( ' cmd ..NACK..')
       else
         Memo1.lines.add( ' cmd ..ACK..');
       state := state + 1;
     end;

     $10B: { IIC function}
     begin
       { read }
       byteStr := '';
       for cnt := 0 to 15 do
       begin
         temp := readIICbyte;
         { ACK byte read }
         ApplyIIC_zero;
         byteStr := byteStr + ' '+intToHex( temp,2 );
       end;

       Memo1.lines.add( intToHex( cnt3, 2 )+ '0 : ' +
                        byteStr );

       cnt3  := cnt3 + 1;
       if  ( ComboBox3.ItemIndex < 0 ) then
         ComboBox3.ItemIndex := 0;

       memSize := ( 1 shl ComboBox3.ItemIndex ) * 1024;
       if  cnt3 >= ( memSize / 16 ) then
       begin
         state := state + 1;
       end;
     end;

     $10C: { IIC function}
     begin
       state := state + 1;
     end;

     $10D: { IIC function}
     begin
       ApplyIICStop;
       state := $1000
     end;


     $110: { IIC function}
     begin

       { Read 24L16B device }
       Memo1.lines.add( ' Reading 24L16B device ');

       { CMD.W ADDR ADDR }
       { send control 0xA0  write }
       if writeIICbyte( $A0 ) then
         Memo1.lines.add( ' cmd ..NACK..')
       else
         Memo1.lines.add( ' cmd ..ACK..');

       { start Address low Byte}
       if writeIICbyte( $00 ) then
         Memo1.lines.add( ' adr ..NACK..')
       else
         Memo1.lines.add( ' adr ..ACK..');

       ApplyIICStop;
       state := state + 1;
     end;

     $111: { IIC function}
     begin
       ApplyIICStart;
       { CMD.R getDATA getDATA }
       if writeIICbyte( $A1 ) then
         Memo1.lines.add( ' cmd ..NACK..')
       else
         Memo1.lines.add( ' cmd ..ACK..');
       state := state + 1;
     end;

     $112: { IIC function}
     begin
       { read }
       byteStr := '';
       for cnt := 0 to 15 do
       begin
         temp := readIICbyte;
         { ACK byte read }
         ApplyIIC_zero;
         byteStr := byteStr + ' '+intToHex( temp,2 );
       end;

       Memo1.lines.add( intToHex( cnt3, 2 )+ '0 : ' +
                               byteStr );

       cnt3  := cnt3 + 1;


       if  ( ComboBox3.ItemIndex < 0 ) then
         ComboBox3.ItemIndex := 0;

       memSize := ( 1 shl ComboBox3.ItemIndex ) * 1024;

       if  cnt3 >= ( memSize / 16 ) then
       begin
         state := state + 1;
       end;
     end;


     $114: { IIC function}
     begin
       ApplyIICStop;
       state := $1000
     end;





     $180: { IIC function}
     begin
       InitButtonStates;

       ConnectComPort;
       Memo1.lines.add( ' .. IIC mode...');
       chipAddress := $0000;
       ApplyIICpower;
       cnt3 := 0;
       state := state + 1;
       chipAddress := 0;
       nackSeen := false
     end;

     $188: { IIC function}
     begin
       state := state + 1;
       if ComboBox2.ItemIndex = 0 then
         state := $190;

     end;

     $189: { IIC function}
     begin
       ApplyIICStart;
       { send control 0xA0  write }
       nackSeen := nackSeen or  writeIICbyte( $A0 );
       { start Address high byte}
       nackSeen := nackSeen or  writeIICbyte( hiByte(chipAddress) );
       { start Address low byte }
       nackSeen := nackSeen or  writeIICbyte( LoByte(chipAddress) );

       state := state + 1;

     end;

     $18A: { IIC function}
     begin
       { now program memory }
       for cnt := 0 to 63 do
       begin
         { data Byte }
         nackSeen := nackSeen or writeIICbyte( hexData.data[ chipAddress + cnt ] );
       end;
       ApplyIICStop;
       { now allow chip to program }
       if nackSeen then
         Memo1.lines.add( '0x'+intToHex(chipAddress + cnt, 4 )+ ' adr ..NACK..')
       else
         Memo1.lines.add( '0x'+intToHex(chipAddress + cnt, 4 )+' adr ..ACK..');

       chipAddress := chipAddress + 63;

       if  ( ComboBox3.ItemIndex < 0 ) then
         ComboBox3.ItemIndex := 0;

       memSize := ( 1 shl ComboBox3.ItemIndex ) * 1024;

       if  chipAddress >= memSize then
         state := $1000
       else
         state := $189;
     end;


     $18B: { IIC function}
     begin
       ApplyIICStop;
       state := state + 1;
     end;


     $18C: { IIC function}
     begin

{       ApplyIIC_one; }
       state := state + 1;
     end;

     $18D: { IIC function}
     begin
       ApplyIICStop;
       state := $1000
     end;

     $190: { IIC function}
     begin
       ApplyIICStart;
       { send control 0xA0 +hi( chipAddress ) write }
       nackSeen := nackSeen or  writeIICbyte( $A0 + hiByte(chipAddress)*2 );
       { start Address low byte }
       nackSeen := nackSeen or  writeIICbyte( LoByte(chipAddress) );
       state := state + 1;

     end;

     $191: { IIC function}
     begin
       { now program memory }
       for cnt := 0 to 15 do
       begin
         { data Byte }
         nackSeen := nackSeen or writeIICbyte( hexData.data[ chipAddress + cnt ] );
       end;
       ApplyIICStop;

       { now allow chip to program }
       if nackSeen then
         Memo1.lines.add( '0x'+intToHex(chipAddress + cnt, 4 )+ ' adr ..NACK..')
       else
         Memo1.lines.add( '0x'+intToHex(chipAddress + cnt, 4 )+' adr ..ACK..');

       chipAddress := chipAddress + 16;

       if  ( ComboBox3.ItemIndex < 0 ) then
         ComboBox3.ItemIndex := 0;

       memSize := ( 1 shl ComboBox3.ItemIndex ) * 1024;

       // Memo1.lines.add( '+++ 0x'+intToHex(chipAddress + cnt, 4 )+'  ');

       if  chipAddress <  memSize then
         state := $190
       else
         state := $1000;
     end;


     $192: { IIC function}
     begin
       ApplyIICStop;
       state := state + 1;
     end;

     $193: { IIC function}
     begin
       state := state + 1;
     end;

     $194: { IIC function}
     begin
       ApplyIICStop;
       state := $1000
     end;

     {------------------------------------------------------------}



     { I2C Display }

     { The display is a 20 x 4 display with a pic chip front end
12345678901234567890|
--------------------+
Freq: 0000 0000     |
 time: XX:XX:00     |
start: XX:XX  XX:XX |
 end : XX:XX  XX:XX |
--------------------+
--------------------+
                    |
                    |
                    |
                    |
--------------------+

     }
     $200: { IIC function for Crownhill i2c display }
     begin
       InitButtonStates;

       ConnectComPort;
       Memo1.lines.add( ' .. IIC mode...');
       chipAddress := $0000;
       ApplyIICpower;
       cnt3 := 0;
       state := state + 1;

     end;

     $204: { IIC function}
     begin
       ApplyIICStart;
       state := state + 1;

     end;

     $205: { IIC function}
     begin
       { CMD.W ADDR ADDR }
       { send control 0xA0  write }
       if writeIICbyte( $C6 ) then
         Memo1.lines.add( ' cmd ..NACK..')
       else
         Memo1.lines.add( ' cmd ..ACK..');

       if writeIICbyte( 12 ) then
         Memo1.lines.add( ' cmd ..NACK..')
       else
         Memo1.lines.add( ' cmd ..ACK..');

       state := state + 1;
       cnt3  := $1;

       if writeIICbyte( 12 ) then
         Memo1.lines.add( ' cmd ..NACK..')
       else
         Memo1.lines.add( ' cmd ..ACK..');

     end;

     $206: { IIC function}
     begin
       { CMD.W ADDR ADDR }
       { send control 0xA0  write }


       if writeIICbyte( ord( Edit3.text[cnt3] )  ) then
         Memo1.lines.add( ' cmd ..NACK..')
       else
         Memo1.lines.add( ' cmd ..ACK..');

       cnt3  := cnt3 + 1;
       if cnt3 > length(Edit3.text) then
       begin
         state := state + 1;
         cnt3 := $20;
       end

     end;

     $20A: { IIC function}
     begin
        if writeIICbyte( 4 ) then
           Memo1.lines.add( ' cmd ..NACK..')
         else
           Memo1.lines.add( ' cmd ..ACK..');

       state := state + 1;
       cnt3  := $20
     end;



     $20B: { IIC function}
     begin
       { CMD.W ADDR ADDR }
       { send control 0xA0  write }


       { start Address High Byte}
       if writeIICbyte( cnt3 ) then
         Memo1.lines.add( ' adr ..NACK..')
       else
         Memo1.lines.add( ' adr ..ACK..');

       if  cnt3 = $40  then
       begin
         if writeIICbyte( 17 ) then
           Memo1.lines.add( ' cmd ..NACK..')
         else
           Memo1.lines.add( ' cmd ..ACK..');
       end;


       cnt3  := cnt3  + 1;

       if  cnt3 >= $FF  then
       begin
         ApplyIICStop;
         state := state + 1;
       end

     end;


     $20C: { IIC function}
     begin
       state  := $1000;
     end;



     { bulk erase }


     $A00:            { bulk erase }
     begin
       Memo1.lines.add( ' ..Adding CodeProtection...');

       {
       * Apply Code protection,
       * so that the remove code protection also clears prog and data memory
       }
       wrtCmd( LD_CONF );    { $2000 }
       wrtData( $0000 );
       wrtCmd(INC_ADDR);     { $2001 }
       wrtCmd(INC_ADDR);     { $2002 }
       wrtCmd(INC_ADDR);     { $2003 }

       wrtCmd(INC_ADDR);     { $2004 }
       wrtCmd(INC_ADDR);     { $2005 }
       wrtCmd(INC_ADDR);     { $2006 }
       wrtCmd(INC_ADDR);     { $2007 }
       wrtCmd( PROG );
       state  := state + 1;

     end;

     $A02:            { bulk erase }
     begin
       Remove5VandVPP;
       resetData;
       resetClk;
       state  := state + 1;
     end;

     $A04:            { bulk erase }
     begin
       Apply5VandVPP;
       state  := state + 1;
     end;

     $A08:            { bulk erase }
     begin
       Memo1.lines.add( ' ..RemovingCodeProtection...');
       wrtCmd( LD_CONF );    { $2000 }
       wrtData( $3FFF );

       wrtCmd(INC_ADDR);     { $2001 }
       wrtCmd(INC_ADDR);     { $2002 }
       wrtCmd(INC_ADDR);     { $2003 }

       wrtCmd(INC_ADDR);     { $2004 }
       wrtCmd(INC_ADDR);     { $2005 }
       wrtCmd(INC_ADDR);     { $2006 }
       wrtCmd(INC_ADDR);     { $2007 }

       wrtCmd( DIS_PROTECT1);
       wrtCmd( DIS_PROTECT2);
       wrtCmd( PROG );
       state  := state + 1;

     end;

     $A0A:
     begin
       Memo1.lines.add( ' ..CodeProtectEnd...');

       { finish off code protection removal }
       wrtCmd( DIS_PROTECT1);
       wrtCmd( DIS_PROTECT2);

       Remove5VandVPP;
       resetData;
       resetClk;
       state := $1000;
     end;



     $A0D:
     begin
       Memo1.lines.add( ' ..erase Prog...');
     { do a bulk erase of data memory }
       { State := $A09; }
       wrtCmd( LD_DATA_MEM );
       wrtData( $FFFF );
       wrtCmd( ERASE_PROG );
       wrtCmd( PROG );
       state  := state + 1;
     end;

     $A10:
     begin
       Memo1.lines.add( ' ..erase Data...');

       { do a bulk erase of program memory }
       { State := $A09; }
       wrtCmd( LD_DATA_MEM );
       wrtData( $FFFF );
       wrtCmd( ERASE_DATA );
       wrtCmd( PROG );
       state  := state + 1;
     end;


     $A14:            { bulk erase }
     begin
       Memo1.lines.add( ' ..end of Bulk Erase Chip...');
       Remove5VandVPP;
       resetData;
       resetClk;
       state  := state + 1;
     end;

     $A18:
     begin
       state := $1000;
     end;

     $A20:
     begin
       Memo1.lines.add( ' ..erase Data...');

       { do a bulk erase of program memory }
       { State := $A09; }
       wrtCmd( LD_CONF );

       wrtData( $0000 );
       wrtCmd( ERASE_PROG );

       state  := state + 1;
     end;

     $A30:
     begin
       Memo1.lines.add( ' ..erase Data...');

       { do a bulk erase of program memory }
       { State := $A09; }
       wrtCmd( LD_CONF );

       wrtData( $0000 );
       wrtCmd( ERASE_DATA );

       state  := state + 1;
     end;

     $A40:
     begin
       Memo1.lines.add( ' ..erase Data...');

       { do a bulk erase of program memory }
       { State := $A09; }
       wrtCmd( LD_CONF );

       wrtData( $0000 );
       wrtCmd( ERASE_DATA );

       state  := $1000;
     end;















     $AF0: { Program the location}
     begin
       wrtCmd( PROG_STOP ); {  For 16F877 use NO_ERASE_PROG }
       state := $B02;

       //state := $AF1;
     end;


     $AF1: { Program the location}
     begin
       wrtCmd( PROG_STOP ); {  For 16F877 use NO_ERASE_PROG }
       state := $AF2;
     end;

     $AF2: { Program the location}
     begin
       state := $B02;
     end;


     $AFC: { Program the location}
     begin
       case RG_device.ItemIndex of
       2:
       begin
         wrtCmd(RD_PRG_MEM);
         temp := rdData;
         //label14.caption := 'conf:'+IntToHex( temp ,4);
         wrtCmd(  INC_ADDR  );
         state := $B00;
       end
       else
       begin
         state := $B00;
       end;
       end;{case}
     end;


     $B00: { Program Program Memory }
     begin

       Memo1.lines.add( ' ..Programming Program Memory 10F204...');
       Memo1.lines.add( ' ');
       chipAddress := $0000;
       state := state + 1;
     end;

     $B01: { Program the location}
     begin
       wrtCmd( LD_PRG_MEM );
       wrtData( hexData.data[ chipAddress ] );
       wrtCmd( PROG_NO_ERASE ); {  For 16F877 use NO_ERASE_PROG }

       case RG_device.ItemIndex of
       2:
       begin
         state := $AF0
       end
       else
       begin
         state := $B02;
       end;
       end;{case}
     end;

     $B02: { Program the rest}
     begin
       { after delay test if program worked }
       wrtCmd(RD_PRG_MEM);
       temp := rdData;
       { test if last location programmed? }
       if temp <> hexData.data[ chipAddress ] then
       begin
         Memo1.lines.add( 'Prog ' +intToHex(chipAddress,4)
                         +' Error:'+intToHex(temp,4)+'<>'
                         +intToHex(hexData.data[ chipAddress ],4) );
         Memo1.lines.add( ' ' );
         Errors := TRUE;
       end else
       begin
         { program was successful }
         Label6.caption := 'location: ' +intToHex(chipAddress,4)+' ok:'+
                           intToHex(temp,4)+'=='+
                           intToHex(hexData.data[ chipAddress ],4) ;

        Memo1.lines.strings[ Memo1.lines.count-1 ] := 'Programming '+ Label6.caption ;

       end;
       { inc through memory that does not need programming }
       finished := false;
       While not finished do
       Begin
          getTicks := GetTickCount();   { not used - gets ticks since windows started }
          skipped := false ;
          if  ( hexData.data[ chipAddress ] = $3FFF )    then
          begin
            Label6.caption := 'Programming prog skipping '+ intToHex(chipAddress,4);
            Memo1.lines.strings[ Memo1.lines.count - 1 ] := Label6.caption ;
            skipped := true ;
          end;
          { increment address }
          wrtCmd( INC_ADDR );
          chipAddress := chipAddress + 1;
          if    ( hexData.data[ chipAddress ] <> $3FFF )
             or ( chipAddress > $3FF ) then
             // or ( chipAddress > $1FF ) then
          begin
            finished := true;
          end;
       end;
       { wind state back to program next location }
       state := $B01;
       if chipAddress > $3FF then
       //if chipAddress > $1FF then
       begin
         state := $C00;
       end else
       begin
         if ( skipped ) then
         begin
           { if skipped then delay start of programming next location }
           state := $B01;
         end else
         begin
           wrtCmd( LD_PRG_MEM );
           wrtData( hexData.data[ chipAddress ] );
           wrtCmd( PROG_NO_ERASE ); {  For 16F877 use NO_ERASE_PROG }

           case RG_device.ItemIndex of
           2:
             state := $AF0
           else
             state := $B02;
           end;{ case }


         end
       end;

     end;


     $B03: { Finish programming 10F204 }
     begin
       state := $C00;
     end;


     $B04: { Program Data Memory}
     begin
       Memo1.lines.add( ' ..Programming Data Memory...');
       Memo1.lines.add( ' ');
       chipAddress := $2100;
       state := $B05;
     end;



     $B05: { Program Data Memory}
     begin
       wrtCmd( LD_DATA_MEM );
       wrtData( hexData.data[ chipAddress ] );
       state := state + 1;
       wrtCmd( PROG_NO_ERASE );
       state := $B06;
     end;

     $B06: { Program Data Memory }
     begin
       if  ( hexData.data[ chipAddress ] <> $3FFF ) then
       begin
         wrtCmd(RD_DATA_MEM);
         temp := rdData;
         if (temp AND $00FF) <> ( hexData.data[ chipAddress ] AND $00FF ) then
         begin
           Memo1.lines.add( 'Prog ' +intToHex(chipAddress,4)
                         +' Error:'+intToHex(temp,4)+'<>'
                         +intToHex(hexData.data[ chipAddress ],4) );
           Memo1.lines.add( ' ' );
           Errors := TRUE;
         end else
         begin
           Label6.caption := 'Location: ' +intToHex(chipAddress,4)+' ok:'+
               intToHex(temp,4)+'=='+intToHex(hexData.data[ chipAddress ],4) ;
           Memo1.lines.strings[ Memo1.lines.count - 1 ] := 'Programming '+ Label6.caption ;
         end;
       end;

       wrtCmd( INC_ADDR );
       chipAddress := chipAddress + 1;
       { skip locations that are $3FFF, assumes chip erased  }

       while ( ( hexData.data[ chipAddress ] = $3FFF ) and  ( chipAddress < $2100+256 ) ) do
       begin
         Label6.caption := 'Programming data skipping '+ intToHex(chipAddress,4) ;
         Memo1.lines.strings[ Memo1.lines.count - 1 ] := Label6.caption ;
         wrtCmd( INC_ADDR );
         chipAddress := chipAddress + 1;
       end;
       state := $B05;
       if chipAddress > $2100+255 then
       begin
         state := $C00;
       end
     end;




     $B08: { Program Configuration Memory}
     begin
       Memo1.lines.add( ' ..Programming Configuration Memory...');
       Memo1.lines.add( ' ');

       case RG_device.ItemIndex of
       2:
       begin
         { prog 10F204 fuses }
         { only available before first INC_ADDRESS }
         state := $60;

       end
       else
       begin
         { prog Other fuses }
         chipAddress := $2000;

         wrtCmd(  LD_CONF );
         wrtData( $3FFF   ); {}

         wrtCmd( LD_PRG_MEM );
         { The Buffer PIC holds back the ppCLKO for 1 ms }
         wrtData( hexData.data[ chipAddress ] );
         state := state + 1;
         wrtCmd( PROG_NO_ERASE );
         state := $B09;
       end;
       end;{case}

       chipAddress := $2000;

       wrtCmd(  LD_CONF );
       wrtData( $3FFF   ); {}

       wrtCmd( LD_PRG_MEM );
       { The Buffer PIC holds back the ppCLKO for 1 ms }
       wrtData( hexData.data[ chipAddress ] );
       state := state + 1;
       wrtCmd( PROG_NO_ERASE );
       state := $B09;
     end;

     $B09: { Program }
     begin
       wrtCmd(RD_PRG_MEM);
       temp := rdData;
       if  chipAddress = $2006 then
       begin
         Label9.caption := 'Chip ID read as: ' +intToHex(temp,4) ;
       end;

       if ( temp <> hexData.data[ chipAddress ] ) and ( chipAddress <> $2006 ) then
       begin
         Memo1.lines.add( 'Prog ' +intToHex(chipAddress,4)
                         +' Error:'+intToHex(temp,4)+'<>'
                         +intToHex(hexData.data[ chipAddress ],4) );
         Memo1.lines.add( ' ' );
         Errors := TRUE;
       end else
       begin
         Label6.caption := 'location ' +intToHex(chipAddress,4)+' ok:'+intToHex(temp,4)+'=='+intToHex(hexData.data[ chipAddress ],4) ;
         Memo1.lines.strings[ Memo1.lines.count - 1 ] := 'Programming '+ Label6.caption ;
       end;

       wrtCmd( INC_ADDR );
       chipAddress := chipAddress + 1;

       state := $B09;
       if chipAddress > $2007 then
       begin
         state := $C00;
       end else
       begin
         wrtCmd( LD_PRG_MEM );
         wrtData( hexData.data[ chipAddress ] );
         state := state + 1;
         wrtCmd( PROG_NO_ERASE );
         state := $B09;
       end;
     end;


     { turn off Programming }
     $C00:
     Begin
       if Errors = TRUE then
              Memo1.Lines.Add('----Errors!!!-------')
       else
              Memo1.Lines.Add('--------------------');
       Remove5VandVPP;
       { do it again for data }
       state := 1;
       case progMode of

         { repeat for next }
         progProg:  progMode := progData;
         progData:  progMode := progFuses;
       else
         state := $1000;
         if Errors = TRUE then
              Memo1.Lines.Add('----Errors!!!-------')
         else
              Memo1.Lines.Add('--- No Errors !  ---');
       Remove5VandVPP;
       end;


       Label5.caption := 'Finished';
     end;




     $1000:
     Begin
       MFuses.Visible := True;
       MData.Visible  := True;
       MProg.Visible  := True;

       state := 0;
       resetClk;
       resetData;
       Remove5VandVPP;
       Form1.Cursor :=  crDefault;

       Button1.enabled  :=true;
       Button2.enabled  :=true;
       Button3.enabled  :=true;
       Button4.enabled  :=true;
       Button5.enabled  :=true;

       Button6.enabled  :=true;
       Button7.enabled  :=true;
       Button8.enabled  :=true;
       Button9.enabled  :=true;
       Button10.enabled :=true;

       Button11.enabled :=true;
       Button12.enabled :=true;
       Button13.enabled :=true;
       Button14.enabled :=true;
       Button15.enabled :=true;

       Button16.enabled :=true;
       Button17.enabled :=true;


       BitBtn1.enabled :=false;
       Memo1.lines.add( ' ..Finished...');
       DisConnectComPort;
     End;


     { Other States }
     else
       if  state <> 0 then
       begin
         state  := state + 1;
       end;
     end;
end;

{ read Data }
procedure TForm1.Button6Click(Sender: TObject);
begin
  Errors   := FALSE;
  MData.lines.clear;
  progMode := readData;
  state    := 1;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  Errors := FALSE;
  MFuses.lines.clear;
  progMode := readFuses;
  state    := 1;

end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  Errors   := FALSE;
  progMode := readFuses;
  state    := $1000;

end;

procedure TForm1.Button8Click(Sender: TObject);
var
   cnt : integer;
begin
 Errors   := FALSE;
  progMode := progProg ;
  state    := $100  ;
end;

{ Program }
procedure TForm1.Button9Click(Sender: TObject);
begin
  Errors   := FALSE;
  progMode := progProg ;
  state    := $1       ;
end;

{ Bulk Erase }
procedure TForm1.Button10Click(Sender: TObject);
begin
  Errors   := FALSE;
  progMode := bulkEraseProg;
  state    := $1;

  RG_device.ItemIndex := 0;
end;

procedure TForm1.Button11Click(Sender: TObject);
begin
  Errors   := FALSE;
  progMode := progData ;
  state    := $1       ;

end;

procedure TForm1.Button12Click(Sender: TObject);
begin
  Errors   := FALSE;
  progMode := progFuses ;
  state    := $1       ;

end;

procedure TForm1.ReopenLast1Click(Sender: TObject);
begin
    Memo1.Lines.Clear;
    MProg.Lines.Clear;
    MData.Lines.Clear;
    MFuses.Lines.Clear;
    Memo1.Lines.LoadfromFile(FileName);

    processMemo;
end;


procedure TForm1.processMemo;
var
   cnt, cnt2 : integer;
   lineStr   : string;
begin
    ReopenLast1.Enabled := True;
    Button2.Enabled     := True;
    HexData.maxProgAddress      := $0;
    for cnt := 0  to maxPicData -1 do
    begin
      HexData.data[cnt] := $3FFF ; { Unprogrammed state }
    end;

    { process the HEX file read into the memo }

    for cnt := 0  to Form1.Memo1.Lines.count do
    begin
         ProcessLine(     HexData, Form1.Memo1.Lines[cnt] );
    end;


    Form1.Mfuses.Lines.add( '' );
    Form1.Mfuses.Lines[ 0 ] := IntToHex( $2000 , 4    )+' : ' ;
    for cnt := $2000+0 to $2000+7 do
    begin
      Form1.Mfuses.Lines[0] := Form1.Mfuses.Lines[0]+
                               IntToHex(HexData.data[cnt],4)+' ';
    end;

    {Form1.Mfuses.Lines.add( '' ); }
    Form1.Mfuses.Lines[ 1 ] := '10F204: '+IntToHex( $0FFF , 4    )+' : ' ;

{    Form1.Mfuses.Lines.add( '' );   }
    Form1.Mfuses.Lines[ 2 ] :=  'MaxProgAddress:' + IntToHex( hexData.maxProgAddress, 4 );


    Form1.MData.Visible := False;
    for cnt2:= 0 to ( 64 div 8 ) do
    begin
      Form1.MData.Lines.add( '' );
      lineStr := '';
      for cnt := $2100+cnt2*8  to $2100+cnt2*8+7 do
      begin
        lineStr := lineStr + IntToHex( HexData.data[cnt], 4 )+' ';
      end;
      Form1.MData.Lines[cnt2] := IntToHex( $2100 + (cnt2*8), 4 )+' : ' + lineStr ;
    end;
    Form1.MData.Visible := True;

    Form1.MProg.Visible := False;

    for cnt2:= 0 to ( $3FF div 8 ) do
    begin
      Form1.MProg.Lines.add( '' );
      lineStr := '';
      for cnt := $0000+cnt2*8  to $0000+cnt2*8+7 do
      begin
        lineStr := lineStr+IntToHex( HexData.data[cnt], 4 )+' ';
      end;
      Form1.MProg.Lines[ cnt2 ] := IntToHex( $0000 + cnt2 * 8, 4 )+' : ' + lineStr ;
    end;

    Form1.MProg.Visible := True;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
{     IniFile  := TIniFile.Create('ppdelp.Ini'); }
     IniFile  := TRegIniFile.Create('ppdelp.Ini');
     FileName := IniFile.ReadString('files','lastFile','');
     FileNameA[0] := IniFile.ReadString('files','lastFile0','');
     FileNameA[1] := IniFile.ReadString('files','lastFile1','');
     FileNameA[2] := IniFile.ReadString('files','lastFile2','');
     FileNameA[3] := IniFile.ReadString('files','lastFile3','');
     FileNameA[4] := IniFile.ReadString('files','lastFile4','');
     FileName := IniFile.ReadString('files','lastFile','');

     ComboBox1.Items.Insert( 0 , FileNameA[4] );
     ComboBox1.Items.Insert( 0 , FileNameA[3] );
     ComboBox1.Items.Insert( 0 , FileNameA[2] );
     ComboBox1.Items.Insert( 0 , FileNameA[1] );
     ComboBox1.Items.Insert( 0 , FileNameA[0] );

     Caption  := FileName;
     ComboBox1.Text := FileName;

     if ( Filename <> '' ) then
     begin
       Memo1.Lines.Clear;
       Memo1.Lines.LoadfromFile(FileName);
       processMemo;
     end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     IniFile.WriteString('files','lastFile',FileName);
     IniFile.Free;

end;

{ Prog Chip }
procedure TForm1.Button1Click(Sender: TObject);
begin
  Errors   := FALSE;
  progMode := progProg ;
  state    := $1       ;
end;

{ Reload File }
procedure TForm1.Button2Click(Sender: TObject);
begin
     ReopenLast1Click( sender );
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
     Form1.Close
end;

procedure TForm1.About1Click(Sender: TObject);
begin
  Form2.ShowModal;
end;

procedure TForm1.file11Click(Sender: TObject);
begin
     Filename := Caption;
     ComboBox1.text :=  Filename ;
end;


procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  Filename := ComboBox1.Text;
  if ( Filename <> '' ) then
  begin
    Memo1.Lines.Clear;
    Memo1.Lines.LoadfromFile(FileName);
    processMemo;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Errors   := FALSE;
  MData.lines.clear;
  progMode := bulkEraseData;
  state    := 1;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin

  Errors   := FALSE;
  MData.lines.clear;
  progMode := bulkEraseBoth;
  state    := $1;
  RG_device.ItemIndex := 1;

end;

procedure TForm1.Button13Click(Sender: TObject);
begin
  Errors   := FALSE;
  MData.lines.clear;
  progMode := bulkEraseBoth;
  state    := $180;

end;

procedure TForm1.Button14Click(Sender: TObject);

var
   cnt : integer;
begin
  Errors   := FALSE;
  progMode := progProg ;
  state    := $200  ;

end;

procedure TForm1.Button15Click(Sender: TObject);
begin
  Errors   := FALSE;
  progMode := bulkEraseProg;
  state    := $50  ;
  label9.caption := 'conf:'+IntToHex( HexData.data[$0FFF],4);

  RG_device.ItemIndex := 2;
end;

procedure TForm1.Button16Click(Sender: TObject);
begin
  Errors   := FALSE;
  state    := $60  ;
  label9.caption := 'conf:'+IntToHex( HexData.data[$0FFF],4);
  RG_device.ItemIndex := 2;

end;


procedure TForm1.Button17Click(Sender: TObject);
begin
  Errors   := FALSE;
  progMode := progProg ;
  state    := $1       ;
  RG_device.ItemIndex := 2;

end;

end.
